//
//  GIWrapper.m
//  squish
//
//  Created by Da-Woon Jung on 2009-03-03.
//  Copyright 2006-9 Da Woon Jung. All rights reserved.
//

#import "GIWrapper.h"
#import <QuickTime/QuickTime.h>


@implementation GIWrapper

- (id)initWithPath: (NSString *)aPath
{
    self = [super init];
    if (self)
    {
        OSErr err;
        OSType pathDataRefType;
        err = QTNewDataReferenceFromFullPathCFString((CFStringRef)aPath, (QTPathStyle)kQTNativeDefaultPathStyle, 0, &pathDataRef, &pathDataRefType);
        if (noErr == err)
        {
            err = GetGraphicsImporterForDataRefWithFlags(pathDataRef, pathDataRefType, &gi, 0);
            if (noErr != err)
            {
                DisposeHandle(pathDataRef);
                pathDataRef = nil;
                [self release];
                self = nil;
            }
        }
    }
    return self;
}

- (void)dealloc
{
    if (gi) CloseComponent(gi);
    if (pathDataRef) DisposeHandle(pathDataRef);
    [super dealloc];
}


- (ComponentInstance)gi
{
    return gi;
}

- (NSSize)size
{
    if (NSEqualSizes(NSZeroSize, size))
    {
        Rect srcRect;
        OSErr err = GraphicsImportGetSourceRect(gi, &srcRect);
        if (noErr == err)
        {
            size.width  = srcRect.right  - srcRect.left;
            size.height = srcRect.bottom - srcRect.top;
        }
    }
    return size;
}

- (void)setSize: (NSSize)aSize
{
    Rect dstRect;
    dstRect.left = dstRect.top = 0;
    dstRect.right  = aSize.width;
    dstRect.bottom = aSize.height;
    GraphicsImportSetDestRect(gi, &dstRect);
    size = aSize;
}
@end
