/*
 *  SquishCompressNotifier.mm
 *  squish
 *
 *  Created by Da Woon Jung on 6/26/06.
 *
 */

#import <Cocoa/Cocoa.h>
#import "SquishCompressNotifier.h"
#import "SquishProgressController.h"

#define SQUISH_COMPRESS_UPDATE_INTERVAL 2

SquishCompressNotifier::SquishCompressNotifier(SquishProgressController *aProgressController) :
    progressController(aProgressController),
    progressTime(0),
    aborted(false)
{
}

void SquishCompressNotifier::update(double progress)
{
    time_t now = time(NULL);
    if (progressTime == 0)
        progressTime = now;
    else
    {
        if ((now - progressTime) > SQUISH_COMPRESS_UPDATE_INTERVAL)
        {
            progressTime = now;
            if (![progressController refresh])
                this->abort();
        }
    }
}

void SquishCompressNotifier::abort()
{
    aborted = true;
}

bool SquishCompressNotifier::isAborted()
{
    return aborted;
}
