//
//  SquishExportOptionsController.mm
//  squish
//
//  Created by Da Woon Jung on 6/23/06.
//

#import "SquishExportOptionsController.h"
#import <squish/squish.h>
using namespace squish;


@implementation SquishExportOptionsController

- (id)init
{
    self = [super initWithWindowNibName: @"ExportOptions"];
    if (self)
    {
        [SquishExportOptionsController registerDefaults];
    }

    return self;
}

+ (void)registerDefaults
{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults registerDefaults:
        [NSDictionary dictionaryWithObjectsAndKeys:
            [NSNumber numberWithBool: NO], @"assembleMipmaps",
            [NSNumber numberWithInt:  kColourClusterFit], @"quality",
            [NSNumber numberWithBool: NO], @"weightByAlpha",
            [NSNumber numberWithInt:  kColourMetricPerceptual], @"metric",
            [NSNumber numberWithInt:  kDxt1], @"outputFormat",
            [NSNumber numberWithBool: YES], @"genMipmaps",
            [NSNumber numberWithInt:  kAlphaUnchanged], @"premulAlpha",
            [NSNumber numberWithInt:  kMipmapPNG], @"mipmapFormat",
            nil]
        ];
}

- (void)windowDidBecomeKey:(NSNotification *)aNotification
{
    [[self window] setLevel: NSNormalWindowLevel];
}

- (void)windowWillClose:(NSNotification *)aNotification
{
    [NSApp tryToPerform: @selector(abortConvert:) with: nil];
}

- (IBAction)showMyHelp: (id)aSender
{
    [NSApp tryToPerform: @selector(showMyHelp:) with: self];
}

- (void)terminate: (id)aSender
{
    [NSApp terminate: aSender];
}
@end
