//
//  SquishProgressController.h
//  SquishDDS
//
//  Created by Da Woon Jung on 05/05/16.
//  Copyright 2005. All rights reserved.
//

#import <Cocoa/Cocoa.h>

enum {
    kSquishNoChoice = -1,
    kSquishStop = 0,

    kSquishReplace = 1,
    kSquishNoReplace = 2,

    kSquishProfileOverride = 3,
    kSquishProfileUseEmbedded = 4
};


@interface SquishProgressController : NSWindowController
{
    IBOutlet NSButton *profileConfirmApplyAll;
    IBOutlet NSTextField *profileConfirmTitle;
    IBOutlet NSView *profileConfirmView;
    IBOutlet NSTextField *profileEmbeddedName;
    IBOutlet NSPopUpButton *profileOverrideMenu;
    IBOutlet NSProgressIndicator *progressBar;
    IBOutlet NSTextField *progressItem;
    IBOutlet NSTextField *progressTitle;
    IBOutlet NSView *progressView;
    IBOutlet NSButton *replaceConfirmApplyAll;
    IBOutlet NSTextField *replaceConfirmTitle;
    IBOutlet NSView *replaceConfirmView;

    int _replaceChoice;
    int _profileChoice;
    int _profileOverrideChoice;
    NSModalSession _modalSession;
}
- (IBAction)doProfileEmbedded:(id)sender;
- (IBAction)doProfileOverride:(id)sender;
- (IBAction)doReplace:(id)sender;
- (IBAction)doStop:(id)sender;

- (void)startProgress;
- (void)endProgress;

- (BOOL)runModalLoop;
- (BOOL)refresh;
- (void)setProgressTitleText:(NSString *)title;
- (void)setProgressItemText:(NSString *)item;
- (void)setProgressItemCount:(double)count;
- (BOOL)incrementProgress;
- (void)setProgressIndeterminate:(BOOL)indeterminate;

- (BOOL)showReplaceConfirmIfNecessaryForFile:(NSString *)aFile;
- (void)showReplaceConfirm:(BOOL)shouldShow forFile:(NSString *)aFile;
- (int)replaceChoice;

- (BOOL)showProfileConfirmIfNecessaryForFile:(NSString *)aFile
                         embeddedProfileName:(NSString *)aEmbedProfileName;
- (void)showProfileConfirm:(BOOL)shouldShow forFile:(NSString *)aFile;
- (int)profileChoice;
- (int)profileOverrideChoice;
@end
