#ifndef _SQUISH_IMAGE_UTILS_H_
#define _SQUISH_IMAGE_UTILS_H_
/*
 *  imageutils.h
 *  squish
 *
 *  Created by Da Woon Jung on 2007-05-04.
 *  Copyright 2007 Da Woon Jung. All rights reserved.
 */

#include <Carbon/Carbon.h>
#include <Accelerate/Accelerate.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
    
extern CMProfileRef CreateICCProfileFromPath(const char *iccProfilePath);
extern CMProfileRef CreateProfileFromSystemICCProfileName(CFStringRef profileName);
extern CMProfileRef CreateICCGenericRGBProfile();
extern CMProfileRef CreateICCGenericGrayProfile();
extern CMProfileRef CreateICCsRGBProfile();
extern CMProfileRef CreateSystemProfile();
extern CFStringRef CopyProfileDescriptionCFString(CMProfileRef prof);

extern void PremultiplyImageAlpha(unsigned char *data,
                                  size_t width, size_t height,
                                  size_t bytesPerRow);
extern void UnpremultiplyImageAlpha(unsigned char *data,
                                    size_t width, size_t height,
                                    size_t bytesPerRow);
extern void ArrangeNormalMapChannels(unsigned char *data,
                                     size_t width, size_t height,
                                     int aSamplesPerPixel);
#ifdef __cplusplus
}
#endif

#endif /* _SQUISH_IMAGE_UTILS_H_ */
